

var site = {};


site.head = function(title, subtitle){
	return	"<div class='head'><table class='page' align='center'><tr>" +
			"<td class='title'>" + title + "</td>" +
			"<td class='subtitle'>" + subtitle + "</td>" +
			"</tr></table></div>";
}

site.menu = function(left, right){
	return	"<div class='menu'><table class='page' align='center'><tr>" +
			"<td class='left'>" + left + "</td>" +
			"<td class='right'>" + right + "</td>" +
			"</tr></table></div>";
}

site.main = function(){
	return	"<div class='body'><table class='page' align='center'><col class='main'/><col class='right'/><tr><td class='main'>";
}

site.foot = function(){
	return	"</td></tr></table></div>";
}

site.copyright = function(message){
	return	"<div class='copyright'><table class='page' align='center'><tr>" +
			"<td>" + message + "</td>" +
			"</tr></table></div>";
}

site.reference = function(){
	var s = "";
	s += "<ul class='reference'>";
		s += "<li><a>Active</a><ul>";
			s += "<li><a>System</a><ul>"
				s += "<li><a href='../system/object.htm'>Object</a>";
				s += "<li><a href='../system/html.htm'>HTML</a>";
				s += "<li><a href='../system/model.htm'>Model</a>";
				s += "<li><a href='../system/format.htm'>Format</a>";
				s += "<li><a href='../system/template.htm'>Template</a>";
				s += "<li><a href='../system/control.htm'>Control</a>";
			s += "</ul>";
			s += "<li><a>Formats</a><ul>"
				s += "<li><a href='../formats/string.htm'>String</a>";
				s += "<li><a href='../formats/number.htm'>Number</a>";
				s += "<li><a href='../formats/date.htm'>Date</a>";
			s += "</ul>";
			s += "<li><a>HTTP</a><ul>"
				s += "<li><a href='../http/request.htm'>Request</a>";
			s += "</ul>";
			s += "<li><a>Text</a><ul>"
				s += "<li><a href='../text/table.htm'>Table</a>";
			s += "</ul>";
			s += "<li><a>XML</a><ul>"
				s += "<li><a href='../xml/table.htm'>Table</a>";
			s += "</ul>";
			s += "<li><a>Templates</a><ul>"
				s += "<li><a href='../templates/box.htm'>Box</a>";
				s += "<li><a href='../templates/text.htm'>Text</a>";
				s += "<li><a href='../templates/item.htm'>Item</a>";
				s += "<li><a href='../templates/list.htm'>List</a>";
				s += "<li><a href='../templates/row.htm'>Row</a>";
				s += "<li><a href='../templates/header.htm'>Header</a>";
				s += "<li><a href='../templates/scroll.htm'>Scroll</a>";
			s += "</ul>";
			s += "<li><a>Controls</a><ul>"
				s += "<li><a href='../controls/grid.htm'>Grid</a>";
			s += "</ul>";
		s += "</ul>";
	s += "</ul>";
	return s;
}

site.tutorial = function(){
	var s = "";
	s += "<ul class='reference'>";
		s += "<li><a>Tutorial</a><ul>";
			s += "<li><a>Introduction</a><ul>"
				s += "<li><a href='../../introduction/helloworld/index.htm'>Hello World</a>";
			s += "</ul>";
			s += "<li><a>HTML</a><ul>"
				s += "<li><a href='../../html/tags/index.htm'>Tags</a>";
				s += "<li><a href='../../html/attributes/index.htm'>Attributes</a>";
				s += "<li><a href='../../html/styles/index.htm'>Styles</a>";
			s += "</ul>";
			s += "<li><a>Grid</a><ul>"
				s += "<li><a href='../../grid/intro/index.htm'>Quick Start</a>";
				s += "<li><a href='../../grid/data/index.htm'>Data Sources</a>";
				s += "<li><a href='../../grid/formats/index.htm'>Number Formatting</a>";
				s += "<li><a href='../../grid/style/index.htm'>Visual Style</a>";
				s += "<li><a href='../../grid/mouseover/index.htm'>Mouseover Effects</a>";
				s += "<li><a href='../../grid/selection/index.htm'>Selections</a>";
			s += "</ul>";
		s += "</ul>";
	s += "</ul>";
	return s;
}


site.base = function(){
	var i, src = "common/site.js", scripts = document.getElementsByTagName("script");
	for (i=0; i<scripts.length; i++){if (scripts[i].src.match(src)){ return scripts[i].src.replace(src, "")}}
	return "";
}

site.home = function(){
	return (window.location.protocol == "file:") ? "readme.htm": "index.html";
}

site.adjustFonts = function(){
	try {
		if (window.navigator.userAgent.match("Linux")) {
			document.body.style.font = "menu";
		}
	}
	catch(error){
	}
}

site.example = function(source){
	try {

		var text = document.getElementById(source).value;
		var style = document.getElementById(source).getAttribute("target");

		var name = source + "-frame";
		var f = "<iframe name='" + name + "' style='" + style +"' frameborder=\"0\"></iframe>";
		document.write(f);

		var doc = frames[name].document;
		doc.open();
		doc.write("<html><head>");
		doc.write("<style> body, html {margin:0px; padding: 0px; overflow: hidden; font: menu} </style>");
		doc.write("<link href=\"../../../../runtime/classic/activeui.css\" rel=\"stylesheet\" type=\"text/css\" ></link>");
		doc.write("<style>.active-row-highlight .active-row-cell {background-color: threedshadow}</style>");
		doc.write("<s" + "cript src=\"../../../../runtime/activeui.js\"></s" + "cript>");
		doc.write("</head><body>");
		doc.write("<s" + "cript>" + document.getElementById(source).value + "</s" + "cript>");

		window.setTimeout(function(){
				doc.write("</body></html>");
				doc.close()
		}, 100);

	}
	catch(e){
	}
}



var $header = {toString: function(){

	site.adjustFonts();

	var s = "", base = site.base(), home = site.home();
	s += site.head("[ActiveUI]", "Cross-browser DHTML widgets toolkit");
	s += site.menu(	"<a href='" + base + home + "'>Home</a>|" +
					"<a href='" + base + "examples.htm'>Examples</a>|" +
					"<a href='" + base + "documentation/tutorial/introduction/helloworld/index.htm'>Documentation</a>",
					"@ SourceForge :: " +
					"<a href='http://sourceforge.net/forum/forum.php?forum_id=310655' target='_blank' title='Open the ActiveUI support forum on SourceForge.'>Forums</a>|" +
					"<a href='http://sourceforge.net/project/showfiles.php?group_id=90231' target='_blank' title='Download the demo package from SourceForge.'>Download</a>");

	s += site.main();

	return s;
}};


var $column = {toString: function(){
	return "</td><td class='right'>";
}};

var $reference = {toString: function(){
	return 	"<h2><a href='../../tutorial/introduction/helloworld/index.htm'>Tutorial</a></h2>" +
			"<h2><a href='../../reference/system/object.htm'>Reference</a></h2>" +
			"<hr/>" + site.reference() + "<hr/>";
}};

var $tutorial = {toString: function(){
	return 	"<h2><a href='../../../tutorial/introduction/helloworld/index.htm'>Tutorial</a></h2>" +
			"<h2><a href='../../../reference/system/object.htm'>Reference</a></h2>" +
			"<hr/>" + site.tutorial() + "<hr/>";
}};

var $footer = {toString: function(){
	var s = "";
	s += site.foot();
	s += site.copyright("Copyright &copy; 2003 ActiveUI Software Ltd. All Rights Reserved.");
	return s;
}};
