/*
	This patch modifies sorting and resizing behavior of
	Active.Controls.Grid class (lib/controls/grid.js)

	added by Tal Golan, 17 Nov 2003
*/

Active.Controls.Grid.patch = function(){

	var obj = this.prototype;

	/* Begin code added by Tal Golan, 17 Nov 2003 */

	var isSortable = 1;
	var isResizeable = 1;

	obj.isSortable = function( sortState ) { isSortable = sortState; };
	obj.isResizeable = function( resizeState ) { isResizeable = resizeState; };

	/* End code added by Tal Golan, 17 Nov 2003 */

//	------------------------------------------------------------

	var startColumnResize = function(header){

		/* Begin code added by Tal Golan, 17 Nov 2003 */

		if( isResizeable == 0 ) return true;

		/* End code added by Tal Golan, 17 Nov 2003 */

		var el = header.element();
		var pos = event.clientX;
		var size = el.offsetWidth;
		var grid = this;

		var doResize = function(){
			var el = header.element();
			el.style.width = size + event.clientX - pos;
			el = null;
		};

		var endResize = function(){

			var el = header.element();

			el.detachEvent("onmousemove", doResize);
			el.detachEvent("onmouseup", endResize);
			el.detachEvent("onlosecapture", endResize);
			el.releaseCapture();

			var width = size + event.clientX - pos;
			el.style.width = width;

			var ss = document.styleSheets[document.styleSheets.length-1];
			var i, selector = ".active-column-" + header.getItemProperty("index");
			for(i=0; i<ss.rules.length;i++){
				if(ss.rules[i].selectorText == selector){
					ss.rules[i].style.width = width;
					el = null;
					grid.getTemplate("layout").action("adjustSize");
					return;
				}
			}
			ss.addRule(".active-column-" + index, "width:" + width + "px");
			el = null;
			grid.getTemplate("layout").action("adjustSize");
		};

		el.attachEvent("onmousemove", doResize);
		el.attachEvent("onmouseup", endResize);
		el.attachEvent("onlosecapture", endResize);
		el.setCapture();

//		break object reference to avoid memory leak
		el = null;

		event.cancelBubble = true;
	};

	obj.setAction("startColumnResize", startColumnResize);

//	------------------------------------------------------------

	obj.sort = function(index){

		/* Begin code added by Tal Golan, 17 Nov 2003 */

		if( isSortable == 0 ) return true;

		/* End code added by Tal Golan, 17 Nov 2003 */

		var i, v1, v2, a = {}, rows = this.getRowProperty("values"), direction = "ascending";

		if ((this.getSortProperty("index") == index) &&
			(this.getSortProperty("direction") == "ascending")) {
			direction = "descending";
		}

		for (i=0; i<rows.length; i++) {

			/* Begin code added by Tal Golan, 17 Nov 2003 */

			v1 = this.getDataProperty("text", i, index).toLowerCase();

			/* End code added by Tal Golan, 17 Nov 2003 */

			v2 = Number(v1.replace(/[ ,]/g, ""));
			a[i] = isNaN(v2) ? v1 : v2;
		}

		function ascending(x, y) {return a[x] > a[y] ? 1 : ( a[x] == a[y] ? 0 : -1 )}
		function descending(x, y) {return a[x] > a[y] ? -1 : ( a[x] == a[y] ? 0 : 1 )}

		rows.sort(direction == "ascending" ? ascending : descending);

		this.setRowProperty("values", rows);

		this.setSortProperty("index", index);
		this.setSortProperty("direction", direction);
	};

};

Active.Controls.Grid.patch();
