/*****************************************************************

	ActiveUI 0.2.2 - cross-browser DHTML widgets toolkit.
	Copyright (C) 2003 ActiveUI Software Ltd. All Rights Reserved. 
	More information at http://www.activeui.net/

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*****************************************************************/

Active.Controls.Grid = Active.System.Control.subclass();

Active.Controls.Grid.create = function(){

/****************************************************************

	Documentation for this module is not yet available.

*****************************************************************/

	var obj = this.prototype;

//	------------------------------------------------------------

	obj.setClass("controls", "grid");

//	------------------------------------------------------------

	obj.defineTemplate("message",	new Active.HTML.DIV);
	obj.defineTemplate("layout", 	new Active.Templates.Scroll);
	obj.defineTemplate("data", 		new Active.Templates.List);
	obj.defineTemplate("left",		new Active.Templates.List);
	obj.defineTemplate("top",		new Active.Templates.List);

	obj.setTemplate("data/item", 	new Active.Templates.Row);
	obj.setTemplate("left/item",	new Active.Templates.Item);
	obj.setTemplate("top/item", 	new Active.Templates.Header);


//	------------------------------------------------------------

	obj.defineModel("row");
	obj.defineProperty("row/count", function(){return this.getDataProperty("count")} );
	obj.defineProperty("row/index", function(i){return i});
	obj.defineProperty("row/order", function(i){return i});
	obj.definePropertyArray("row/text", function(i){return this.getRowOrder(i) + 1});
	obj.definePropertyArray("row/image", "none");
	obj.definePropertyArray("row/value", function(i){return i});

//	------------------------------------------------------------

	obj.defineModel("column");
	obj.defineProperty("column/count", 0 );
	obj.defineProperty("column/index", function(i){return i});
	obj.defineProperty("column/order", function(i){return i});
	obj.definePropertyArray("column/text", function(i){return "Column " + i});
	obj.definePropertyArray("column/image", "none");
	obj.definePropertyArray("column/value", function(i){return i});
	obj.definePropertyArray("column/tooltip", "");

//	------------------------------------------------------------

	obj.defineModel("data");
	obj.defineProperty("data/count", 0);
	obj.defineProperty("data/index", function(i){return i});
	obj.defineProperty("data/text", "");
	obj.defineProperty("data/image", "none");
	obj.defineProperty("data/value", function(i,j){return this.getDataText(i,j)});

//	------------------------------------------------------------

	obj.defineModel("items"); 

//	------------------------------------------------------------

	obj.defineModel("selection");
	obj.defineProperty("selection/index", -1); 
	obj.defineProperty("selection/multiple", false);
	obj.defineProperty("selection/count", 0);
	obj.definePropertyArray("selection/value", 0);

	obj.defineModel("dummy");
	obj.defineProperty("dummy/count", 0);
	obj.definePropertyArray("dummy/value", -1);

//	------------------------------------------------------------

	obj.defineModel("sort");
	obj.defineProperty("sort/index", -1);
	obj.defineProperty("sort/direction", "none");

//	------------------------------------------------------------

	obj.getLeftTemplate = function(){
		var template = this.defaultLeftTemplate();
		template.setDataModel(this.getRowModel());
		template.setItemsModel(this.getRowModel());
		template.setSelectionModel(this.getDummyModel());
		return template;
	};

//	------------------------------------------------------------

	obj.getTopTemplate = function(){
		var template = this.defaultTopTemplate();
		template.setDataModel(this.getColumnModel());
		template.setItemsModel(this.getColumnModel());
		template.setSelectionModel(this.getDummyModel());
		return template;
	};

//	------------------------------------------------------------

	obj.getDataTemplate = function(){
		var template = this.defaultDataTemplate();
		template.setDataModel(this.getDataModel());
		template.setItemsModel(this.getRowModel());
		return template;
	};

//	------------------------------------------------------------

	obj.getColumnTemplate = function(i){return this.getTemplate("data/item/item", i)};
	obj.setColumnTemplate = function(template, i){this.setTemplate("data/item/item", template, i)};

	obj.getRowTemplate = function(i){return this.getTemplate("data/item", i)};
	obj.setRowTemplate = function(template, i){this.setTemplate("data/item", template, i)};

//	deprecated - use column template instead
	obj.getCellTemplate = function(i){return this.getColumnTemplate(i)};
	obj.setCellTemplate = function(template, i){this.setColumnTemplate(template, i)};

//	------------------------------------------------------------

	obj.setContent(function(){return this.getLayoutTemplate()});

//	------------------------------------------------------------

	obj.setColumnHeaderHeight = function(height){
		var layout = this.getTemplate("layout");
		layout.getContent("top").setStyle("height", height);
		layout.getContent("corner").setStyle("height", height);
		layout.getContent("left").setStyle("padding-top", height);
		layout.getContent("data").setStyle("padding-top", height);
	};

	obj.setRowHeaderWidth = function(width){
		var layout = this.getTemplate("layout");
		layout.getContent("left").setStyle("width", width);
		layout.getContent("corner").setStyle("width", width);
		layout.getContent("top").setStyle("padding-left", width);
		layout.getContent("data").setStyle("padding-left", width);
	};

//	------------------------------------------------------------

	var startColumnResize = function(header){

		
		var el = header.element();
		var pos = event.clientX;
		var size = el.offsetWidth;
		var grid = this;

		var doResize = function(){
			var el = header.element();
			var sz = size + event.clientX - pos;
			el.style.width = sz < 5 ? 5 : sz;
			el = null;
		};

		var endResize = function(){

			var el = header.element();

			el.detachEvent("onmousemove", doResize);
			el.detachEvent("onmouseup", endResize);
			el.detachEvent("onlosecapture", endResize);
			el.releaseCapture();

			var width = size + event.clientX - pos;
			if (width < 5) {width = 5}
			el.style.width = width;

			var ss = document.styleSheets[document.styleSheets.length-1];
			var i, selector = "#" + grid.getId() + " .active-column-" + header.getItemProperty("index");
			for(i=0; i<ss.rules.length;i++){
				if(ss.rules[i].selectorText == selector){
					ss.rules[i].style.width = width;
					el = null;
					grid.getTemplate("layout").action("adjustSize");
					return; 
				}
			}
			ss.addRule(selector, "width:" + width + "px");
			el = null;
			grid.getTemplate("layout").action("adjustSize");
		};

		el.attachEvent("onmousemove", doResize);
		el.attachEvent("onmouseup", endResize);
		el.attachEvent("onlosecapture", endResize);
		el.setCapture();

//		break object reference to avoid memory leak
		el = null;

		event.cancelBubble = true;
	};

	obj.setAction("startColumnResize", startColumnResize);

//	------------------------------------------------------------

	var setSelectionIndex = obj.setSelectionIndex;

	obj.setSelectionIndex = function(index){
		var current = this.getSelectionValues();
		this.setSelectionValues([index]);
		setSelectionIndex.call(this, index);

		for (var i in current) {
			this.getTemplate("data/item", current[i]).refresh();
		}

		this.getTemplate("data/item", index).refresh();
		this.action("selectionChanged");
	};

//	------------------------------------------------------------

	var selectRow = function(src){
		this.setProperty("selection/index", src.getProperty("item/index"));
	};

	var selectMultipleRows = function(src){
		if (!this.getProperty("selection/multiple")){
			return this.action("selectRow", src);
		}
		var index = src.getProperty("item/index");
		var selection = this.getSelectionValues();
		selection.push(index);
		this.setSelectionValues(selection);
		setSelectionIndex.call(this, index);

		this.getTemplate("data/item", index).refresh();
		this.action("selectionChanged");
	};

	obj.setAction("selectRow", selectRow);
	obj.setAction("selectMultipleRows", selectMultipleRows);

//	------------------------------------------------------------

	obj.sort = function(index){
		var a = [], direction = "ascending";
		var rows = this.getRowProperty("values");

		if (this.getSortProperty("index") == index) {
			if (this.getSortProperty("direction") == "ascending") {direction = "descending"}
			rows.reverse();
		}
		else {
			for (var i=0; i<rows.length; i++) {
				var text = "" + this.getDataProperty("value", i, index);
				var value = Number(text.replace(/[ ,%\$]/gi, "").replace(/\((.*)\)/, "-$1"));
				a[i] = isNaN(value) ? text.toLowerCase() + " " : value;
			}
			rows.sort(function(x,y){return a[x] > a[y] ? 1 : (a[x] == a[y] ? 0 : -1)});
		}

		this.setRowProperty("values", rows);
		this.setSortProperty("index", index);
		this.setSortProperty("direction", direction);
	};


	obj.setAction("columnSort", function(src){
		var i = src.getItemProperty("index");
		window.status = "Sorting...";
		this.sort(i);
		this.refresh();
		this.timeout(function(){window.status = ""});
	});

//	------------------------------------------------------------

	var _getRowOrder = function(i){
		return this._rowOrders[i];
	};

	var _setRowValues = obj.setRowValues;

	obj.setRowValues = function(values){
		_setRowValues.call(this, values);

		var i, max = values.length, orders = [];
		for(i=0; i<max; i++){
			orders[values[i]] = i;
		}

		this._rowOrders = orders;
		this.getRowOrder = _getRowOrder;
	};
};

Active.Controls.Grid.create();