/*****************************************************************

	ActiveUI 0.2.2 - cross-browser DHTML widgets toolkit.
	Copyright (C) 2003 ActiveUI Software Ltd. All Rights Reserved. 
	More information at http://www.activeui.net/

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*****************************************************************/

Active.HTTP.Request = Active.System.Model.subclass();

Active.HTTP.Request.create = function(){

/****************************************************************

	Documentation for this module is not yet available.

*****************************************************************/

	var obj = this.prototype;

	// -------------------------------------------------------------------------

	obj.defineProperty("URL");
	obj.defineProperty("async", true);
	obj.defineProperty("requestMethod", "GET");
	obj.defineProperty("requestData", "");
	obj.defineProperty("responseType", "text/xml");

	// -------------------------------------------------------------------------

	obj.setNamespace = function(name, value){
		this._namespaces += " xmlns:" + name + "=\"" + value + "\"";
	};

	obj._namespaces = "";

	// -------------------------------------------------------------------------

	obj.setParameter = function(name, value){
		this["_" + name + "Parameter"] = value;
		if (!this._parameters.match(name)) {this._parameters += " " + name}
	};

	obj._parameters = "";

	// -------------------------------------------------------------------------

	obj.request = function(){
		var self = this;

		this._ready = false;

		var i, data = "", params = this._parameters.split(" ");
		for (i=1; i<params.length; i++){
			data += params[i] + "=" + encodeURIComponent(this["_" + params[i] + "Parameter"]) + "&";
		}

		var URL = this._URL;

		if (this._requestMethod != "POST"){
			URL += "?" + data;
			data = null;
		}

		this._http = new ActiveXObject("MSXML2.XMLHTTP");
		this._http.open(this._requestMethod, URL, this._async);
		this._http.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		this._http.send(data);

		if (this._async) {
			this.timeout(wait, 200);
		}
		else {
			returnResult();
		}

		function wait(){
			if (self._http.readyState == 4) {
				self._ready = true;
				returnResult();
			}
			else {
				self.timeout(wait, 200);
			}
		}

		function returnResult(){
			if (self._responseType == "text/xml") {
				self._http.responseXML.setProperty("SelectionLanguage", "XPath");
				self._http.responseXML.setProperty("SelectionNamespaces", self._namespaces);
				if (!self._http.responseXML.xml && self._http.responseText) {
					self._http.responseXML.loadXML(self._http.responseText);
				}
				self.response(self._http.responseXML);
			}
			else {
				self.response(self._http.responseText);
			}
			self._http = null;
		}
	};

	obj.response = function(result){
		if (this.$owner) {this.$owner.refresh()}
	};

	obj.isReady = function(){
		return this._ready;
	};
};

Active.HTTP.Request.create();