/*****************************************************************

	ActiveUI 0.2.2 - cross-browser DHTML widgets toolkit.
	Copyright (C) 2003 ActiveUI Software Ltd. All Rights Reserved. 
	More information at http://www.activeui.net/

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*****************************************************************/

Active.XML.Table = Active.HTTP.Request.subclass();

Active.XML.Table.create = function(){

/****************************************************************

	Documentation for this module is not yet available.

*****************************************************************/

	var obj = this.prototype;
	var _super = this.superclass.prototype;

	// -------------------------------------------------------------------------

	obj.response = function(xml){
		this._xml = xml;
		this._data = this._xml.selectSingleNode(this._dataPath);
		this._items = this._data.selectNodes(this._itemPath);
		_super.response.call(this);
	};

	obj._dataPath = "*";
	obj._itemPath = "*";
	obj._valuePath = "*";

	obj._valuesPath = [];

	obj._formats = [];

	// -------------------------------------------------------------------------

	obj.setColumns = function(array){
		this._valuesPath = array;
	};

	obj.setRows = function(xpath){
		this._itemPath = xpath;
	};

	obj.setTable = function(xpath){
		this._dataPath = xpath;
	};

	obj.setFormat = function(format, index){
		this._formats = this._formats.concat();
		this._formats[index] = format;
	};

	obj.setFormats = function(formats){
		this._formats = formats;
	};

	obj.getCount = function(){
		if (!this._items) {return 0}
		return this._items.length;
	};

	obj.getIndex = function(i){
		return i;
	};

	obj.getText = function(i, j){
		var data = this.getData(i, j);
		var format = this._formats[j];
		return format ? format.dataToText(data) : data;
	};

	obj.getImage = function(){
		return "none";
	};

	obj.getValue = function(i, j){
		var data = this.getData(i, j);
		var format = this._formats[j];
		return format ? format.dataToValue(data) : data;
	};

	obj.getData = function(i, j){
		if (!this._items) {return null}
		var node = null;
		if (this._valuesPath[j]) {
			node = this._items[i].selectSingleNode(this._valuesPath[j]);
		}
		else {
			node = this._items[i].selectNodes(this._valuePath)[j];
		}
		return node ? node.text : null;
	};

};

Active.XML.Table.create();